<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs" :large="false">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Disciplinas</strong>
    </div>
    <div class="infoCorte">*Información con corte a día vencido</div>
    <div class="contenedorPrincipal">
      <div class="instrucciones">
        Aquí verás desplegadas las
        <strong>disciplinas con su calificación final a nivel nacional*</strong>
        <br />
        Selecciona una para verla a detalle.
      </div>
      <v-row v-if="isAutorizado">
        <v-col
          cols="12"
          lg="4"
          class="pa-8"
          v-for="(itemDisciplina, indexItemDisciplina) in disciplinas"
          :key="indexItemDisciplina"
        >
          <Disciplina
            :methods-semaforo="methodsSemaforo"
            :disciplina="itemDisciplina"
          />
        </v-col>
      </v-row>
      <v-row v-else>
        <v-col>
            <h1>{{textoSinAutorizacion}}</h1>
        </v-col>
      </v-row>
    </div>
    <Semaforo />
  </div>
</template>
<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
.infoCorte {
  color: red;
  font-size: 12px;
  padding: 8px 21px 9px 21px;
}
.contenedorPrincipal {
  padding: 20px 65px;
}
.instrucciones {
  padding-bottom: 20px;
}
</style>
<script>
import axios from "axios";
import Semaforo from "@/views/secure/sistema-informacion/dashboards/commons/graficos/Semaforo.vue";
import Disciplina from "@/views/secure/sistema-informacion/dashboards/commons/graficos/Disciplina.vue";
import store from "@/store";
const serviceLocalStorage = store.state.serviceLocalStorage;
export default {
  name: "Component-Disciplinas",
  components: {
    Semaforo,
    Disciplina,
  },
  data() {
    return {
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Sistema de Información",
          disabled: false,
          exact: true,
          to: {
            name: "sistema_informacion",
          },
        },
        {
          text: "Dashboard",
          disabled: true,
        },
        {
          text: "Disciplinas",
          disabled: true,
        },
      ],
      disciplinas: [],
      periodo: {},
      methodsSemaforo: null,
      disciplinasAutorizadas: [],
      isAutorizado: false,
      textoSinAutorizacion: ""
    };
  },
  methods: {
    getPeridoInfo() {
      const self = this;
      axios
        .get("franquicia/periodo/secure/get/actual")
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.getDisciplinas(data);
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },
    getDisciplinas(periodo) {
      const self = this;
      axios
        .get(
          "franquicia/dashboard/secure/grafico/get/disciplina/dashboard",
          periodo
        )
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                self.isAutorizado = true;
                self.textoSinAutorizacion = "";
                data.forEach((item)=>{
                  if(self.disciplinasAutorizadas.includes(item.id_disciplina+"")){
                    self.disciplinas.push(item);
                  }
                });
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },
    setSemaforo(methodsSemaforo) {
      this.methodsSemaforo = methodsSemaforo;
      //this.getPeridoInfo();
      this.getPerfilesAutorizados();
    },

    obtenerPerfilAutorizado(perfiles) {

      let perfilAutorizado = -1;

      store.state.perfiles.forEach((item) => {
        perfiles.forEach((perfil) => {
          if (item.perfil.id_perfil == perfil) {
            perfilAutorizado = perfil;
          }
        });
      });

      return perfilAutorizado;
    },

    getPerfilesAutorizados() {
      const self = this;
      axios
        .get("franquicia/dashboard/secure/parametro/perfilesPerso")
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                if (data.valor) {
                  let perfiles = data.valor.split(",");
                  if (perfiles) {
                    let perfilAutorizado = self.obtenerPerfilAutorizado(perfiles);
                    if(perfilAutorizado !== -1){
                      self.getDisciplinasAutorizadas(perfilAutorizado);
                    }else{
                      self.textoSinAutorizacion = "No cuentas con autorización para ver las disciplinas. Solicita tu acceso con Franquicia";
                    }
                  }
                }
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },

    getDisciplinasAutorizadas(perfil) {
      const self = this;
      axios
        .get("franquicia/dashboard/secure/parametro/perfil" + perfil)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                if (data.valor) {
                  self.disciplinasAutorizadas = data.valor.split(",");
                  self.getPeridoInfo();
                }
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },
    getConfiguracionDisciplina() {
      let body = {
        id_configuracion: null,
        id_protocolo: null,
        id_disciplina: null,
        id_frecuencia: null,
        id_negocio_disciplina: null,
      };

      axios
        .post("franquicia/configuracion/disciplina/secure/getPost", body)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                console.log("Disciplinas: ", data);
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },
  },

  mounted() {
    this.$root.$on("rangoloaded", this.setSemaforo);
  },
  created() {},
};
</script>
